﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Mackoy.Bvets.TsmcInterface
{
    public partial class ConfigForm : Form
    {
        private string[] cabSwitchKeyTexts = { "Horn 1", "Horn 2", "Constant Speed Control", "Music Horn" };
        private string[] atsKeyTexts = new string[16];
        private List<int[]> keyCodeTable = new List<int[]>();

        public ConfigForm()
        {
            InitializeComponent();

            for (int i = 0; i < atsKeyTexts.Length; i++)
            {
                atsKeyTexts[i] = "ATS " + i.ToString();
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            for (int i = 1; i <= 256; i++)
            {
                portList.Items.Add("COM" + i.ToString());
            }
            for (int i = 0; i < cabSwitchKeyTexts.Length; i++)
            {
                addKey(cabSwitchKeyTexts[i]);
                keyCodeTable.Add(new int[2] { -1, i });
            }
            for (int i = 0; i < atsKeyTexts.Length; i++)
            {
                addKey(atsKeyTexts[i]);
                keyCodeTable.Add(new int[2] { -2, i });
            }

            if (TsmcInterface.settings.Port >= 1 && TsmcInterface.settings.Port <= 256)
            {
                portList.SelectedIndex = TsmcInterface.settings.Port - 1;
            }
            selectDropDownList(buttonSKeyList, TsmcInterface.settings.ButtonS);
            selectDropDownList(buttonAKeyList, TsmcInterface.settings.ButtonA);
            selectDropDownList(buttonBKeyList, TsmcInterface.settings.ButtonB);
            selectDropDownList(buttonCKeyList, TsmcInterface.settings.ButtonC);
        }

        private void addKey(string s)
        {
            buttonSKeyList.Items.Add(s);
            buttonAKeyList.Items.Add(s);
            buttonBKeyList.Items.Add(s);
            buttonCKeyList.Items.Add(s);
        }

        private void selectDropDownList(ComboBox list, int[] assign)
        {
            switch (assign[0])
            {
                case -1:
                    if (assign[1] >= 0 && assign[1] < cabSwitchKeyTexts.Length)
                    {
                        list.SelectedIndex = assign[1];
                    }
                    break;
                case -2:
                    if (assign[1] >= 0 && assign[1] < atsKeyTexts.Length)
                    {
                        list.SelectedIndex = assign[1] + cabSwitchKeyTexts.Length;
                    }
                    break;
            }
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            if (portList.SelectedIndex >= 0)
            {
                TsmcInterface.settings.Port = portList.SelectedIndex + 1;
            }
            if (buttonSKeyList.SelectedIndex >= 0)
            {
                TsmcInterface.settings.ButtonS = keyCodeTable[buttonSKeyList.SelectedIndex];
            }
            if (buttonAKeyList.SelectedIndex >= 0)
            {
                TsmcInterface.settings.ButtonA = keyCodeTable[buttonAKeyList.SelectedIndex];
            }
            if (buttonBKeyList.SelectedIndex >= 0)
            {
                TsmcInterface.settings.ButtonB = keyCodeTable[buttonBKeyList.SelectedIndex];
            }
            if (buttonCKeyList.SelectedIndex >= 0)
            {
                TsmcInterface.settings.ButtonC = keyCodeTable[buttonCKeyList.SelectedIndex];
            }

            DialogResult = DialogResult.OK;
            Close();
        }
    }
}
