﻿using System.IO;
using System.Xml.Serialization;

namespace Mackoy.Bvets.TsmcInterface
{
    public class Settings
    {
        private const string filename = "Mackoy.TsmcInterface.xml";
        private string directory = string.Empty;

        private int port = 0;
        private int[] buttonS = { -2, 0 };
        private int[] buttonA = { -2, 1 };
        private int[] buttonB = { -2, 2 };
        private int[] buttonC = { -2, 3 };

        public void SaveToXml()
        {
            try
            {
                if (!Directory.Exists(directory)) Directory.CreateDirectory(directory);

                // XmlSerializerオブジェクトを作成
                // 書き込むオブジェクトの型を指定する
                XmlSerializer serializer = new XmlSerializer(typeof(Settings));

                using (FileStream fs = new FileStream(Path.Combine(directory, filename), FileMode.Create)) // ファイルを開く
                {
                    serializer.Serialize(fs, this); // シリアル化し、XMLファイルに保存する
                }
            }
            catch
            {
            }
        }

        public static Settings LoadFromXml(string directory)
        {
            Settings settings;
            try
            {
                // XmlSerializerオブジェクトの作成
                XmlSerializer serializer = new XmlSerializer(typeof(Settings));

                using (FileStream fs = new FileStream(Path.Combine(directory, filename), FileMode.Open))
                {
                    settings = (Settings)serializer.Deserialize(fs); // XMLファイルから読み込み、逆シリアル化する
                }
            }
            catch
            {
                settings = new Settings();
            }

            settings.directory = directory;

            return settings;
        }

        public int Port
        {
            get { return port; }
            set { port = value; }
        }

        public int[] ButtonS
        {
            get { return buttonS; }
            set { buttonS = value; }
        }

        public int[] ButtonA
        {
            get { return buttonA; }
            set { buttonA = value; }
        }

        public int[] ButtonB
        {
            get { return buttonB; }
            set { buttonB = value; }
        }

        public int[] ButtonC
        {
            get { return buttonC; }
            set { buttonC = value; }
        }
    }
}
